'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getSourceMap = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var getSourceMap = function () {
  var _ref = _asyncToGenerator(_regenerator2.default.mark(function _callee(fileUri, fileContents) {
    var match, sm, base64, match2, index, url, obj;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            match = /\/\/[#@] ?sourceMappingURL=([^\s'"]+)\s*$/m.exec(fileContents);

            if (match && match[1]) {
              _context.next = 3;
              break;
            }

            throw new Error('Source map not found for file: ' + fileUri);

          case 3:
            sm = match[1].toString();

            if (!(sm.indexOf('data:') === 0)) {
              _context.next = 15;
              break;
            }

            base64 = /^data:application\/json;([\w=:"-]+;)*base64,/;
            match2 = sm.match(base64);

            if (match2) {
              _context.next = 9;
              break;
            }

            throw new Error('Sorry, non-base64 inline source-map encoding is not supported.');

          case 9:
            sm = sm.substring(match2[0].length);
            sm = window.atob(sm);
            sm = JSON.parse(sm);
            return _context.abrupt('return', new _sourceMap.SourceMapConsumer(sm));

          case 15:
            index = fileUri.lastIndexOf('/');
            url = fileUri.substring(0, index + 1) + sm;
            _context.next = 19;
            return fetch(url).then(function (res) {
              return res.json();
            });

          case 19:
            obj = _context.sent;
            return _context.abrupt('return', new _sourceMap.SourceMapConsumer(obj));

          case 21:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function getSourceMap(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var _sourceMap = require('source-map');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.getSourceMap = getSourceMap;
exports.default = getSourceMap;